//
//  EnemyList.swift
//  TowerDefense
//
//  Created by 杉本裕樹 on 2016/01/17.
//  Copyright © 2016年 MyName. All rights reserved.
//

import UIKit
import SpriteKit

class EnemyList {
    private var enemies = [Enemy]()
    
    func enemiesCloseToPoint(_ point: CGPoint, distance: Double) -> [Enemy] {
        return enemies.filter {
            let dx = Double(point.x - $0.frame.origin.x)
            let dy = Double(point.y - $0.frame.origin.y)
            let distanceFromEnemy = sqrt(dx*dx + dy*dy)
            
            return distanceFromEnemy < distance
        }
    }
    
    func appendEnemy(_ enemy: Enemy) {
        enemies.append(enemy)
    }
    
    func isAllEnemyRemoved() -> Bool {
        return enemies.filter { $0.parent != nil }.count == 0
    }
}
